
type symbol = string
type stree =
        | Symbol of symbol
        | Execute
        | Apply
        | Define
        | Ipperopp
        | Quote
        | Concat
        | Print
        | Debug
        | Input
        | Seq of stree list

let op_names =
        [ Execute, "x"; Apply, "apply"; Define, "d"; Ipperopp, "ipperopp";
        Debug, "debug"; Concat, "c"; Quote, "q"; Print, "pr"; Input, "inbt" ]

let ops = List.map snd op_names
let op_tags = List.map (fun a, b -> b, a) op_names

module StreeOrder = struct
        type t = stree
        let compare a b = Hashtbl.hash a - Hashtbl.hash b
end

